{config, pkgs, lib, ...}:
let
	createChromiumExtensionFor = browserVersion: { id, sha256, version }:
	{
		inherit id;
		crxPath = builtins.fetchurl {
			url = "https://clients2.google.com/service/update2/crx?response=redirect&acceptformat=crx2,crx3&prodversion=${browserVersion}&x=id%3D${id}%26installsource%3Dondemand%26uc";
			name = "${id}.crx";
			inherit sha256;
		};
		inherit version;
	};
	createChromiumExtension = createChromiumExtensionFor (lib.versions.major pkgs.ungoogled-chromium.version);
in
{

	programs.browserpass.browsers = [ "chromium" ];
	programs.chromium = {
		enable = true;
		package = (pkgs.ungoogled-chromium.override {
			commandLineArgs = [
				"--enable-features=UseOzonePlatform,WebRTCPipeWireCapturer"
				"--ozone-platform=wayland"
			];
		});
		extensions = [ 
			## browserpass
			{
				# id = "naepdomgkenhinolocfifgehidddafch";
				id = "pjmbgaakjkbhpopmakjoedenlfdmcdgm";
				# id = "klfoddkbhleoaabpmiigbmpbjfljimgb";
				# crxPath = "/tmp/a.crx";
			  crxPath = (builtins.fetchurl {
				  url = "https://github.com/browserpass/browserpass-extension/releases/download/3.7.2/browserpass-github-3.7.2.crx";
				  name = "naepdomgkenhinolocfifgehidddafch.crx";
			  });
				updateUrl = "https://github.com/browserpass/browserpass-extension/releases/download/3.7.2/browserpass-github-3.7.2.crx";
			  version = "3.7.2";
			}
			#(createChromiumExtension {
			#	id = "naepdomgkenhinolocfifgehidddafch";
			## "naepdomgkenhinolocfifgehidddafch"
			#  sha256 = "1gwy7fa1076ynaspz8rsfrp29cizgp7dk2wbznaxhbmim9ys6hkq";
			#	version = "3.7.2";
			#})
			## ublock origin
			(createChromiumExtension {
			 id = "cjpalhdlnbpafiamejdnhcphjbkeiagm";
			# "cjpalhdlnbpafiamejdnhcphjbkeiagm"
			  sha256 = "1i14y4sq9vl01wqhlgxmdv6knhjm622llc8ycbq3l2k389shj7ng";
				version = "1.46.0";
			})
			## uMatrix
			(createChromiumExtension {
				id = "ogfcmafjalglgifnmanfmnieipoejdcf";
			# "ogfcmafjalglgifnmanfmnieipoejdcf"
				sha256 = "0l1i79naglp2xbqvkvrw7340749wncdql8dklrklz3b406c01cmf";
				version = "1.4.4";
			})
			## ipvFoo
			(createChromiumExtension {
				id = "ecanpcehffngcegjmadlcijfolapggal";
			# "ecanpcehffngcegjmadlcijfolapggal"
			  sha256 = "1b8ail2sj14xaisw25c29c0hvwn8qv612rg50x8lwajwxh143caf";
				version = "2.3";
			})
			## Vertical Tabs by Michael
			(createChromiumExtension {
				id = "pddljdmihkpdfpkgmbhdomeeifpklgnm";
			# "pddljdmihkpdfpkgmbhdomeeifpklgnm"
				sha256 = "19hb2gmkr4fb4mnsyvak0k1w33m3v9yjsad5lzcm8yamna18829y";
				version = "2.0.4";
			})
		];
	};
}
